-------------------------------------------------------------------------------
-- Dumb Knight
--Copyright (C) 2013  Thoughts of Glought

--This program is free software: you can redistribute it and/or modify
--it under the terms of the GNU General Public License as published by
--the Free Software Foundation, either version 3 of the License, or
--(at your option) any later version.
--------------------------------------------------------------------------------
--This program is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU General Public License for more details.
---------------------------------------------------------------------------------
--You should have received a copy of the GNU General Public License
--along with this program.  If not, see <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------------

local DBK = LibStub("AceAddon-3.0"):GetAddon("Dumbknight")
local DBK_Healers = DBK:NewModule("HealersDBK","AceEvent-3.0","AceTimer-3.0","AceConsole-3.0")
local WarningTimer
local timerCount = 0

--local IsInGroup = true
function DBK_Healers:Enable()
	DBK_Healers:RegisterEvent("PLAYER_ENTERING_WORLD", "setdbkwarningtimer")
	DBK_Healers:RegisterEvent("LFG_COMPLETION_REWARD","cancelWarningTimer")
	DBK_Healers:RegisterEvent("UNIT_COMBAT","underAttackCheck")

end

function DBK_Healers:underAttackCheck(...)
	
	local unitCombat, unitID, descriptor, damageCrits, damage = ...;
	local Random = math.random(1, 14)
    local affectingCombat = UnitAffectingCombat("player");
	local Player_Role = UnitGroupRolesAssigned("player");
	--and Player_Role == "HEALER"
	  if DBK.db.global.healers then
         --DumbKnightEventDumpDB[event] = {...}		
         --DBK:Print(descriptor)
		 
		 
		if unitID == "player" and damage >= 1 and timerCount <= 0 and descriptor == "WOUND"  and Player_Role == "HEALER" then
			--DBK:Print("you are under attack".. Random)
			ChatThrottleLib:SendChatMessage("ALERT", "DumbKnight", "DumbKnight Message: Warning I am under attack.", "INSTANCE_CHAT", nil, nil);
			end
	  end
	  --DBK:Print(descriptor)
		if DBK.db.global.debug then
		
		end
end

function DBK_Healers:cancelWarningTimer()
	DBK_Healers:CancelTimer(WarningTimer)
	timerCount = 0
	if DBK.db.global.debug then
		DBK:Print("dev","Timer Cancelled")
	end
end

function DBK_Healers:setdbkwarningtimer()
	DBK_Healers:ScheduleTimer("sdbkwarningtimer",23)
end

function DBK_Healers:sdbkwarningtimer()
	--if IsInGroup() == false then
	local Player_Role = UnitGroupRolesAssigned("player")
	if  IsInRaid() then
		if IsInGroup() and Player_Role == "TANK" then
			WarningTimer = DBK_Healers:ScheduleRepeatingTimer("dbkwarningtimer" , 2)
			timerCount = 0
		else
		--	DBK:Print("Not in group(Hunter)")
		end
	else
		--if IsInGroup() and IsInRaid() == false then
			WarningTimer = DBK_Healers:ScheduleRepeatingTimer("dbkwarningtimer" , 2)
			timerCount = 0
		--else
			--DBK:Print("Not in group(Hunter)")
		--end
	end
end

function DBK_Healers:dbkwarningtimer()
	timerCount = timerCount + 1
	if timerCount == 1 then
	 --DBK:Print("timer at 1")
	end
	if timerCount == 5 then
	--DBK:Print("timer at 5")
	end
	if timerCount > 6 then
		timerCount = 0
		--DBK:Print("timer at 0")
		--DBK_Healers:underAttackCheck()
	end
	if DBK.db.global.debug then
	-- print(timerCount .. " " .. GetTime())
	end
end