-------------------------------------------------------------------------------
-- Dumb Knight
--Copyright (C) 2013  Thoughts of Glought

--This program is free software: you can redistribute it and/or modify
--it under the terms of the GNU General Public License as published by
--the Free Software Foundation, either version 3 of the License, or
--(at your option) any later version.
--------------------------------------------------------------------------------
--This program is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU General Public License for more details.
---------------------------------------------------------------------------------
--You should have received a copy of the GNU General Public License
--along with this program.  If not, see <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------------

local DBK = LibStub("AceAddon-3.0"):GetAddon("Dumbknight")
local DBK_Paladins = DBK:NewModule("PaladinsDBK")

function DBK_Paladins:DoTanksayings(name)

	local Random = math.random(1, 9)
	local n,r= UnitName(name)n=n and n.. (r and "-"..r or "")
	if (Random == 1) then
		SendChatMessage("DumbKnight Message: I think you meant to queue as a tank because your in protection spec :)","WHISPER",nil,n)
	elseif (Random == 2) then
		SendChatMessage("DumbKnight Message: Protection spec is for tanking please get out of it kind sir or madam.","WHISPER",nil,n)
	elseif (Random == 3) then
		SendChatMessage("DumbKnight Message: You appear to not know how to dps!!!! Step one GET OUT OF PROTECTION SPEC!!!! step two pick Retribution. Thank you and have a good day.","WHISPER",nil,n)
	elseif (Random == 4) then
		SendChatMessage("DumbKnight Message: Hey man tanking is my job don't take my job bro!! Please leave protection spec.","WHISPER",nil,n)
	elseif (Random == 5) then
		SendChatMessage("DumbKnight Message: You know protection is not for dps right? just checking.","WHISPER",nil,n)
	elseif (Random == 6) then
		SendChatMessage("DumbKnight Message: I'm going to bloody your lip if you don't get out of protection.","WHISPER",nil,n)
	elseif (Random == 7) then
		SendChatMessage("DumbKnight Message: Paladin stealing my aggro! please leave protection.","WHISPER",nil,n)
	elseif (Random == 9) then
		SendChatMessage("DumbKnight Message: Do you want to tank? Then queue as tank.","WHISPER",nil,n)
	elseif (Random == 9) then
		SendChatMessage("DumbKnight Message: Hey I didn't queue as healer because I don't plan to heal. So I would assume since you queued as dps you plan on doing dps right? I just ask because your in protection.","WHISPER",nil,n)
	else
	--DBK:Print("Get out of blood!"..playername)
	end
end

function DBK_Paladins:DoHealersayings(name)

	local Random = math.random(1, 13)
	local n,r= UnitName(name)n=n and n.. (r and "-"..r or "")
	if (Random == 1) then
		SendChatMessage("DumbKnight Message: I think you meant to queue as a tank because your in protection spec :)","WHISPER",nil,n)
	elseif (Random == 2) then
		SendChatMessage("DumbKnight Message: Protection spec is for tanking please get out of it kind sir or madam.","WHISPER",nil,n)
	elseif (Random == 3) then
		SendChatMessage("DumbKnight Message: You appear to not know how to dps!!!! Step one GET OUT OF PROTECTION SPEC!!!! step two pick retribution. Thank you and have a good day.","WHISPER",nil,n)
	elseif (Random == 4) then
		SendChatMessage("DumbKnight Message: Hey I rather just heal the tank...you know the guy queued as tank...not dps.....please leave protection spec.","WHISPER",nil,n)
	elseif (Random == 5) then
		SendChatMessage("DumbKnight Message: You know protection is not for dps right? just checking.","WHISPER",nil,n)
	elseif (Random == 6) then
		SendChatMessage("DumbKnight Message: I'm going to bloody your lip if you don't get out of protection.","WHISPER",nil,n)
	elseif (Random == 7) then
		SendChatMessage("DumbKnight Message: Oi good day mate! My heals will stop unless you leave protection!","WHISPER",nil,n)
	elseif (Random == 8) then
		SendChatMessage("DumbKnight Message: Do you want to tank? Then queue as tank.","WHISPER",nil,n)
	elseif (Random == 9) then
		SendChatMessage("DumbKnight Message: I queued as healer the tank queued as tank we are doing our jobs please leave protection so you can do yours!","WHISPER",nil,UnitName(name))
	elseif (Random == 10) then
		SendChatMessage("DumbKnight Message: Oh sorry I would have healed you but i didn't know you were the tank! After all you are showing up as dps but I guess your protection spec is more important","WHISPER",nil,n)
	elseif (Random == 11) then
		SendChatMessage("DumbKnight Message: Never gonna heal you up! Never gonna save your life! Never gonna spec you right! and rez you! Please leave Protection:) thank you","WHISPER",nil,n)
	elseif (Random == 12) then
		SendChatMessage("DumbKnight Message: As you can see I spec for healer because I plan to heal. You should spec for dps!","WHISPER",nil,n)
	elseif (Random == 13) then
		SendChatMessage("DumbKnight Message: There once was a dps Paladin who speced for tanking. Everyone hated him even the healer who refused to heal him....he died....the end","WHISPER",nil,n)
	else
	--DBK:Print("Get out of blood!"..playername)
	end

end

function DBK_Paladins:DoDpssayings(name)
	local Random = math.random(1, 12)
	local n,r= UnitName(name)n=n and n.. (r and "-"..r or "")

	if (Random == 1) then
		SendChatMessage("DumbKnight Message: I think you meant to queue as a tank because your in Protection spec :)","WHISPER",nil,n)
	elseif (Random == 2) then
		SendChatMessage("DumbKnight Message: Protection spec is for tanking please get out of it kind sir or madam.","WHISPER",nil,n)
	elseif (Random == 3) then
		SendChatMessage("DumbKnight Message: You appear to not know how to dps!!!! Step one GET OUT OF PROTECTION SPEC!!!! step two pick Retribution. Thank you and have a good day.","WHISPER",nil,n)
	elseif (Random == 4) then
		SendChatMessage("DumbKnight Message: You know Protection is not for dps right? just checking.","WHISPER",nil,n)
	elseif (Random == 5) then
		SendChatMessage("DumbKnight Message: I'm going to bloody your lip if you don't get out of Protection.","WHISPER",nil,n)
	elseif (Random == 6) then
		SendChatMessage("DumbKnight Message: You can't join the dps club....Because your in tank spec!","WHISPER",nil,n)
	elseif (Random == 7) then
		SendChatMessage("DumbKnight Message: Do you want to tank? Then queue as tank.","WHISPER",nil,n)
	elseif (Random == 8) then
		SendChatMessage("DumbKnight Message: Hey I didn't queue as healer because I don't plan to heal. So I would assume since you queued as dps you plan on doing dps right? I just ask because your in Protection.","WHISPER",nil,n)
	elseif (Random == 9) then
		SendChatMessage("DumbKnight Message: Hey your going to piss off the tank bro. Best leave Protection spec","WHISPER",nil,n)
	elseif (Random == 10) then
		SendChatMessage("DumbKnight Message: Hey your making the healers job harder then it needs to be please leave Protection spec.","WHISPER",nil,n)
	elseif (Random == 11) then
		SendChatMessage("DumbKnight Message: Take it from another dps. dps is a lot easier when your in dps spec.","WHISPER",nil,n)
	elseif (Random == 12) then
		SendChatMessage("DumbKnight Message: Your dps seems low try getting out of tank spec.","WHISPER",nil,n)
	else
	--DBK:Print("Get out of blood!"..playername)
	end
end

function DBK_Paladins:whisperPally()
	local PP_name
	local PP_class
	local PP_Spec
	local PP_Role
	local Player_Role = UnitGroupRolesAssigned("player")
	if IsInGroup() then
		if DBK.db.global.raidwhispers then
			if IsInRaid() then
				for j = 1, GetNumGroupMembers(), 1 do

					PP_name = UnitName("raid"..j)
					PP_class = select(2,UnitClass("raid"..j))
					PP_Spec = GetInspectSpecialization("raid"..j)
					PP_Role = UnitGroupRolesAssigned("raid"..j)
					local n,r= UnitName("raid"..j)n=n and n.. (r and "-"..r or "")
					if PP_class == "PALADIN" and PP_Spec == 66 and PP_Role ~= "TANK" then
						if DBK.db.global.fancy  then
							if Player_Role == "TANK" then
								DBK_Paladins:DoTanksayings("raid"..j)
							elseif Player_Role == "HEALER" then
								DBK_Paladins:DoHealersayings("raid"..j)
							elseif Player_Role == "DAMAGER" then
								DBK_Paladins:DoDpssayings("raid"..j)
							else
								DBK_Paladins:Print("you have no role!")
							end
						else
							SendChatMessage("DumbKnight Message: you are in Protectin spec! Change to your dps spec(Retribution)","WHISPER",nil,n)
						end
					else
					--DBK:Print("Not in blood spec(raid)")
					end
				end
			else
				for j = 1, GetNumSubgroupMembers(), 1 do
					PP_name = UnitName("party"..j)
					PP_class = select(2,UnitClass("party"..j))
					PP_Spec = GetInspectSpecialization("party"..j)
					PP_Role = UnitGroupRolesAssigned("party"..j)
					local n,r= UnitName("party"..j)n=n and n.. (r and "-"..r or "")
					if PP_class == "PALADIN" and PP_Spec == 66  and PP_Role ~= "TANK" then
						if DBK.db.global.fancy  then
							if Player_Role == "TANK" then
								DBK_Paladins:DoTanksayings("party"..j)
							elseif Player_Role == "HEALER" then
								DBK_Paladins:DoHealersayings("party"..j)
							elseif Player_Role == "DAMAGER" then
								DBK_Paladins:DoDpssayings("party"..j)
							else
								DBK_Paladins:Print("you have no role!")
							end
						else
							SendChatMessage("DumbKnight Message: you are in Protectin spec! Change to your dps spec(Retribution)","WHISPER",nil,n)
						end
					else
					--DBK:Print("Not in blood spec (dungeon RW ON)")
					end
				end
			end

		else
			for j = 1, GetNumSubgroupMembers(), 1 do
				PP_name = UnitName("party"..j)
				PP_class = select(2,UnitClass("party"..j))
				PP_Spec = GetInspectSpecialization("party"..j)
				PP_Role = UnitGroupRolesAssigned("party"..j)
				local n,r= UnitName("party"..j)n=n and n.. (r and "-"..r or "")
				if PP_class == "PALADIN" and PP_Spec == 66 and PP_Role ~= "TANK" then
					if DBK.db.global.fancy  then
						if Player_Role == "TANK" then
							DBK_Paladins:DoTanksayings("party"..j)
						elseif Player_Role == "HEALER" then
							DBK_Paladins:DoHealersayings("party"..j)
						elseif Player_Role == "DAMAGER" then
							DBK_Paladins:DoDpssayings("party"..j)
						else
							DBK_Paladins:Print("you have no role!")
						end
					else
						SendChatMessage("DumbKnight Message: you are in Protectin spec! Change to your dps spec(Retribution)","WHISPER",nil,n)
					end
				else
				--DBK_Paladins:Print("Not in Prot Spec (dungeons RW off")
				end
			end
		end

	else
		if DBK.db.global.debug then
			DBK:Print("Not in group(Paladin)")
		end
	end
end